package com.ruoyi.mybasic.common.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;


/**
 * 档案表
 * @author Lou-Zs
 */
@Data
public class Archives {


    /**
     * 档案id(用户编号)
     */
    private Integer userId;
    /**
     * 主要病状
     */
    private String diseaseMain;
    /**
     * 现在病史
     */
    private String diseaseNow;
    /**
     * 既往病史
     */
    private String diseaseBefore;
    /**
     * 最近治疗医院
     */
    private String hospitalName;
    /**
     * 治疗过程
     */
    private String treatmentProcess;
    /**
     * 开始时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    private Date startTime;
    /**
     * 结束时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    private Date endTime;



    /**
     * 照片路径
     */
    private String pictureUrl;
    /**
     * pictureList[]
     */
    private List<String> pictureList;



}
