package com.ruoyi.mybasic.service.Impl;

import com.ruoyi.mybasic.common.domain.BankConfig;
import com.ruoyi.mybasic.mapper.MessageMapper;
import com.ruoyi.mybasic.service.MessageService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;


/**
 * 银行卡实现层
 * @author swh
 */
@Service
public class MessageServiceImpl implements MessageService {

    /** @noinspection SpringJavaInjectionPointsAutowiringInspection*/
    @Autowired
    private MessageMapper messageMapper;

    /**
     * 绑定银行卡 添加到银行卡表中
     * @param bankConfig
     */
    @Override
    public void addBank(BankConfig bankConfig) {
        messageMapper.addBank(bankConfig);
    }

    /**
     * 查询当前人银行卡的当前银行卡 根据银行卡号进行循环查询 是否已经绑定
     * @param userId
     * @return
     */
    @Override
    public List<Integer> listBankCardNo(Long userId) {

        return messageMapper.listBankCardNo(userId);
    }
}
